A framework is a type of software library that provides generic functionality which can be extended by the programmer to build applications.

Flask and Django are good examples of frameworks intended for web development.

A framework is distinguished from a simple library or API.

An API is a piece of software that a developer can use in his or her application.

A framework is more encompassing: your entire application is structured around the framework (i.e. it provides the framework around which you build your software).